predicate sorted(a: array<int>, l: int, u: int)
  reads a
  {
    forall i, j :: 0 <= l <= i <= j <= u < a.Length ==> a[i] <= a[j]
  }

method GnomeSort(a: array?<int>)
  modifies a
  requires a != null
  ensures sorted(a, 0, a.Length-1)
  {
    var i := 0;
    

    while(i < a.Length) 
      invariant 0 <= i <= a.Length
      invariant sorted(a, 0, i - 1)
    {
      if (i == 0 || a[i] >= a[i - 1]) {
          i := i + 1;
      } else {
        a[i], a[i-1] := a[i - 1], a[i];
        i := i - 1;
      }
    }
  }
